#import <objc/Object.h>
#import <stdlib.h>
#import <stdio.h>
#import <objc/zone.h>
#import <mach/mach.h>
#import <math.h>
#import <mach/message.h>
#import <mach/mach_error.h>
#import <string.h>
#import <sound/soundstruct.h>
#import <soundkit/Sound.h>
#import "space.h"


@interface Pvc_Object : Object
{

  int			N,
			N2,
			Nw,
			Nw2, 
			decim, 
			interp,
			valid,
			inPoint,
			outPoint,
			in,
			on,
			insize,
			eof;
  short			*inData,
			*outData;
  float 		freqmlt,
			srate,
			pi,
			twopi,
			synt,
			*Hwin,
			*Wanal,
			*Wsyn,
			*input,
			*buf,
			*channel,
			*output;
  char			*inputFilename,
			*outputFilename;
  BOOL			obank,
			aflag,
			sflag;
  NXZone		*ozone;
  SNDSoundStruct 	*insfh,
			*outsfh;
  port_t 		appToObjPort;
  int			status;
}

enum {IDLE=1,RUNNING=2,PAUSED=3,FINISHING=3};


+ create;
- (float)howFar;
- (int)status;
- init;
- (SNDSoundStruct *)outsfh;
- (SNDSoundStruct *)insfh;
- setDefaults;
- checkArgs:(char *)msg;
- allocateDataspace;
- N: (int) aN;
- Nw: (int) aNw;
- decim: (int) aDecim;
- interp: (int) aInterp;
- freqmlt: (float) aFreqmlt;
- srate: (float) aSrate;
- synt: (float) aSynt;
- aflag: (BOOL) aAflag;
- sflag: (BOOL) aSflag;
- runPvc;
- runFFT;
- makewindows;
- rfft: (BOOL) forward;
- cfft: (BOOL) forward;
- (int) shiftin;
- shiftout;
- overlapadd;
- fold;
- convert;
- unconvert;
- convertFFT;
- unconvertFFT;
- oscbank;
- setInputFilename:(char *) arg;
- setOutputFilename:(char *) arg;
- writeOutputSound;
- kill;
- pause;
- resume;

@end
